/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.person;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.person.boundary.AbstractTagSearchParameters;
import de.ivu.elect.business.person.boundary.TagChangeEvent;
import de.ivu.elect.business.person.boundary.TagConversationStore;
import de.ivu.elect.business.person.boundary.TagExtendedDAO;
import de.ivu.elect.business.person.boundary.TagSearch;
import de.ivu.elect.business.person.boundary.TagSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.person.entity.Tag;
import de.ivu.elect.business.person.entity.TagMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractTagSearchView.COMPONENT_NAME)
@View(viewId = AbstractTagSearchView.VIEW_ID, useCase = UseCasePermission.TAG_SEARCH)
public abstract class AbstractTagSearchView extends AbstractElectSearchView<Tag> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "tagSearchView";
  
  public static final String VIEW_ID = "/person/tag-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractTagSearchView requestHandler;

  @Inject
  private transient TagExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(TagConversationStore.class)
  protected transient TagConversationStore conversationStore;

  @Inject
  protected transient TagSearch search;

  @Inject
  @ConversationGroup(AbstractTagSearchParameters.class)
  protected transient TagSearchParameters searchParameters;

  @Inject
  protected transient TagMeta entityMeta;

  public AbstractTagSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Tag getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Tag entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public TagSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Tag> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Tag> create();
  }

  @Override
  public List<Tag> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Tag> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onTagChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) TagChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractTagSearchView {

    @View
    @Inject
    private transient Instance<AbstractTagSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractTagSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
